"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeMirrorCore = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactCodemirror = require("react-codemirror2");

var _core = require("@material-ui/core");

var _editorTypes = require("./editorTypes");

require("codemirror/lib/codemirror.css");

require("codemirror/mode/xml/xml");

require("codemirror/mode/sql/sql");

require("codemirror/mode/javascript/javascript");

var CodeMirrorCore = function CodeMirrorCore(_ref) {
  var _ref$input = _ref.input;
  _ref$input = _ref$input === void 0 ? {} : _ref$input;
  var value = _ref$input.value,
      _ref$input$onChange = _ref$input.onChange,
      onChange = _ref$input$onChange === void 0 ? function () {} : _ref$input$onChange,
      _ref$meta = _ref.meta,
      valid = _ref$meta.valid,
      error = _ref$meta.error,
      type = _ref.type,
      label = _ref.label,
      _ref$defaultValue = _ref.defaultValue,
      defaultValue = _ref$defaultValue === void 0 ? '' : _ref$defaultValue,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required;
  var _editorTypes$type = _editorTypes.editorTypes[type],
      mode = _editorTypes$type.mode,
      format = _editorTypes$type.format,
      parse = _editorTypes$type.parse,
      stringify = _editorTypes$type.stringify;
  return _react.default.createElement("div", null, _react.default.createElement("span", {
    style: {
      color: '#c4c4c4'
    }
  }, label, required ? ' * ' : ' '), valid ? null : _react.default.createElement("span", {
    style: {
      color: '#ff3d3a'
    }
  }, " (", error, ")"), Boolean(format) && _react.default.createElement(_core.Toolbar, {
    disableGutters: true
  }, _react.default.createElement(_core.Button, {
    onClick: function onClick() {
      return onChange(format(value));
    }
  }, "Format")), _react.default.createElement(_reactCodemirror.Controlled, {
    label: label,
    value: stringify(value || defaultValue),
    options: {
      mode: mode,
      lineNumbers: true,
      lineWrapping: true
    },
    onBeforeChange: function onBeforeChange(editor, data, valueFromEditor) {
      onChange(parse(valueFromEditor));
    }
  }));
};

exports.CodeMirrorCore = CodeMirrorCore;

var valueType = _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array, _propTypes.default.object]);

CodeMirrorCore.propTypes = {
  input: _propTypes.default.shape({
    value: valueType,
    onChange: _propTypes.default.func
  }),
  meta: _propTypes.default.shape({
    valid: _propTypes.default.bool.isRequired,
    error: _propTypes.default.string
  }).isRequired,
  type: _propTypes.default.oneOf(Object.keys(_editorTypes.editorTypes)).isRequired,
  label: _propTypes.default.node.isRequired,
  defaultValue: valueType,
  required: _propTypes.default.bool
};